# CraftPresence

## [v2.4.0+Beta.2](https://github.com/CDAGaming/CraftPresence-Wow-Edition/tree/v2.4.0+Beta.2) (2022-06-06)
[Full Changelog](https://github.com/CDAGaming/CraftPresence-Wow-Edition/commits/v2.4.0+Beta.2) [Previous Releases](https://github.com/CDAGaming/CraftPresence-Wow-Edition/releases)

- [Fix] Fix `GetLocale` functionality  
    - Forgot to replace this reference, my bad.  
- [Change] Adjusted Color Codes to be more recognizable as RGB  
- [Change] Added `current\_toc` to the minimum and maximum toc comments  
    - Further changes to ship soon...  
- [Change] Deprecation of the `CP\_GlobalUtils` namespace  
    - This brings all the addon functions under the `CraftPresence` namespace. As `CP\_GlobalUtils` was only made for internal functions, a migration layer will not be made for this, so those using it are encouraged to use the `CraftPresence` namespace in applicable functions.  
- [Change] Begin v2.4.0 Development  
    - This commit is an entire overhaul of the existing locale logic, in development since v2.2.0.  
    - This identifies as part one of this rewrite, in which the following changes have been made:  
      - Removed usage of `local L = CraftPresence.locale` as locale data is now initialized in `OnInitialize` and thus declaring it beforehand will no longer work. All usages have instead been replaced with `self.locale` or `CraftPresence.locale`.  
      - Moved around the TOC load order so that functions in Utils.lua are now available for Locale files. This effectively also deprecates the `CP\_GlobalUtils` namespace, since that namespace was only added for locales to use critical functions.  
      - To prevent issues in locale data lookup, the `locale` table is initialized as an empty table, so any lookups before AceLocale is initialize will result in empty data. This is better then experiencing a crash, when this addon is designed for plug-and-play.  
- [Change] Updated Github CI dependencies  
    - Bumped checkout from v1 to v3  
- [Change] Part Two of Locale Rewrite  
    - Ported localization to new format to restore prior functionality.  
    - Further usage with the new methods will occur within the v2.3.x pipeline.  
- [Change] Remove unused translations  
- [Fix] Regression fixes for unnecessary Title capitalizations  
- [Change] Part One of Locale Rewrite  
    - Extended the prior dynamic comments to apply to title and usage as well  
    - Adjusted the logic so everything is not considered a button in the locale. As the locale files havent been changed yet, this will cause a lot of untranslated strings, which I've failsafed for the time being.  
    - Added `GetConfigMetadata` to allow better dynamic delivery. `GetConfigComment`, `GetConfigTitle`, and `GetConfigUsage` are the segmented portions of this functions but are classed as helper functions for it. They can be used on their own just fine however.  
    - `SetupConfigIdentifier` has also been added as an internal use function, as it serves no other purpose other then to help setup method execution for the prior 3 methods.  
- [Fix] Fixed a typo in METRICS\_INFO locale  
- [Change] Added an additional param to `GetConfigComment` to allow per-section dynamic comments  
    - Normally this parameter is reserved to apply an additional tag to the comment and default locale lookup.  
    - This is planned to be used for a locale rewrite to improve clarity and for marking "unsafe" fields (IE fields your allowed to edit, but can cause malformed results if done incorrectly). It also allows me to specify more unique info for certain categories, for example *The fact that the processCallback in the Events tab has two return params, `ignore\_event` and `log\_output`*.  
- [Change] Fallback `innerKey` in `GenerateDynamicTable` will no longer be formatted  
    - We don't format any other failsafes so it makes no sense to do so on this line.  
- [Change] Added an additional route to filtering Unit Status Information  
    - Added an `info` table that stores `unitString` from `self.labels` alongside the `key` (Otherwise known as id) that label identifies as, for example: `in\_combat, "message\_here"` as a key,value pair.  
    - Note: This is again meant for advanced usage only or for debugging purposes.  
- [Change] Multiple Adjustments to `GetUnitStatus`  
    - Swapped `refresh` param to the 3rd param, and adjusted it so refresh now controls if `SyncDynamicData` is called before proceeding in method execution. The existing `refresh` case has been moved to `sync` to preserve existing behavior.  
    - Added a `seperator` and `index` optional parameter to the function. This will allow customizing both how `unitInfo` is split up, and for index, specifying an exact part of `unitData` to have. Note that these parameters are for advanced usage, since it can be very technical how this works.  
    - Additionally, a `full\_status` param exists, which will always be the concatenated (by `seperator`) form of `unitInfo`, in order to preserve `sync` behavior. It is advised NOT to use a custom seperator with `sync` enabled, as changing it after a sync can cause duplicated events, which otherwise would not happen under default behaviors.  
    - Clean up now-outdated config logic, most notably `PLAYER\_FLAGS\_CHANGED` which no longer needs a `unitData` comparison. Logic may be changed / a schema layer added if the prior format of this setting causes issues in default behaviors.  
- [Change] Cleanup LuaCheck data  
    - Removes a lot of outdated references due to dynamic conversion over time  
- [Change] Bumped TOC and Metadata for 9.2.5 Retail Support  
- [Change] Added multi-line support to several category comments  
    - Also includes some misc. changes and typo fixes  
- [Fix] Fixed a locale typo  
- [Fix] Added a case for when the  Metric Engine's`stateCallback` changes  
    - This commit allows the `stateCallback` to be processed again if it has been modified, without requiring a reload. Note however, it is still recommended to reload due to duplicate registrations possibly causing issues.  
- [Change] Analytics now have an `unregisterCallback`  
    - This callback allows for unloading analytic data when it is no longer processable, either from being disabled or other reasoning.  
    - This commit also removes the requirement to do /reload when making changes to this menu, due to adding `SyncAnalytics` as the `changedCallback` for the dynamic table as well as rewriting the function to allow for it. Note however, that in most cases disabling a metric engine still requires a reload to purge outside addon data, though `unregisterCallback` may be edited in cases like this to purge remaining metric data (Albeit this is unsafe and not recommended).  
- [Fix] Fixed incorrect spacing between a dynamic table's comment and grp  
    - A spacer has been added between a dynamically generated config table's comment and the rest of the UI in order to patch up a slight ui misconfiguration.  
- [Refactor] `InitializeAnalytics` => `SyncAnalytics`  
    - function name changed due to clearing prior data before execution now, related to an upcoming commit.  
- [Fix] Misc. Fixes before 9.2.5 Preparations  
- [Fix] Added a failsafe for when a property does not exist in `/cp reset`  
    - This fixes a scenario in which you can effectively create infinite values when using the command. Now `reset\_single` has logging for both command success and failure.  
- [Fix] Several fixes for `player\_icon` placeholder  
    - Fixed formatting of the player's race by removing spaces rather then them being replaced by underscores due to the `FormatAsIcon` function.  
    - Corrected the if-case order to where Race is checked before `UnitSex`.  
    - Corrected `result` concatenation to avoid scenarios of `unknown\_gender` or `race\_unknown`. Failure scenarios have been redirected to simply be `unknown`. This code is adjustable, if for example, you wanted the fallback to be a certain race/gender.  
    Migration Notes:  
    - Due to the minor severity of this issue, and the fact that it only effects a subset of races, a migration layer/schema change will not be made for this commit. If users who have edited this config value wish to apply these changes, please run the following command: `/cp reset placeholders player\_icon`  
- Merge branch 'next'  
- [Fix] fixed incorrect documentation for a Schema note  
    - v4.5 is officially set as the v2.2.0 Schema Version  
- [Change] Sync Locale for deDE + Remove unused translations  
- [Change] Added Support for Custom Formatting Rules in RPC Fields  
    - `messageFormatCallback` and `messageFormatType` have been added to all applicable RPC fields. For buttons, only the label uses dynamic formatting rules, for obvious reasons. For images, `keyFormatCallback` and `keyFormatType` have been added to differentiate between the key and message formatting.  
    - Added function `ParseDynamicFormatting` to dynamically parse with either a string or function references. If a string is specified for the callback, it will use `GetCaseData` (Valid Types for this are `lower|upper|no-dupes|icon`).  
    - As a minor performance improvement, the `result` field has been removed from `self.buttons` and has instead been moved out of the placeholders loop and into the final `supply\_data` if-case.  
- [Change] Code Cleanup for aforementioned refactor  
    - Migrate a portion of the self.db.profile usages to SetProperty and GetProperty. The more advanced usages have remained as-is to prevent issues.  
- [Refactor] Get|Set FromDb => Get|Set Property  
    - Refactored for a clearer name, and ease of usage.  
- [Refactor] Multiple Performance Improvements for `SyncDynamicData`  
    - Supplying pre-filled data for `SyncDynamicData` is no longer allowed, since with `supply\_data` in use, there is no viable need for it.  
    - Moved the initial data table creation to after the `placeholders` for loop, as well as deprecated and removed the usage of `SetFormats`. Both of these should give ample improvements in performance as well as reduce any excessive memory usage.  
    - `SyncDynamicData` will now only return the data table when `supply\_data` is true, otherwise it does not return anything.  
    - Note: The `GetCaseData` calls will soon be replaced with two new fields in the config, that is currently being internally tested. Once these are ready, users will be able to specify the post-processing format of the strings, instead of it being hard-coded. This is the last remaining portion of the addon that is hardcoded rpc-wise.  
- [Change] Added Documentation to list supported types in `GetCaseData`  
- [Change] Added Dynamic Support for `presenceData`  
    - For debuggers, `presenceData` is now available as a field, which will show both the callbacks and results from parsing after `SyncDynamicData`  
    - `rpcData` creation has been moved from `EncodeConfigData` to the `SyncDynamicData` method, and is bound by a nil check to the `data` table as well as a new parameter named `supply\_data`.  
- [Fix] Fixed migration regressions between v4.1 and v4.5  
- [Fix] Fixed an issue with unrelated migration warnings  
- Revert "[Fix] Attempt to fix a migration error"  
- Revert "[Fix] Attempt 2 at fixing a migration issue"  
- [Fix] Attempt 2 at fixing a migration issue  
- [Change] Adjusted migration note for v4.5 schema  
- [Fix] Attempt to fix a migration error  
- [Change] Initial Implementation of making the presence fields dynamic  
    - Presence Settings have been moved to their own tab, while `showMinimapIcon` and `showWelcomeMessage` have been moved into the general tab.  
    - The dynamics are not supported yet in `EncodeConfigData`, until certain functions can be deprecated and adjusted to allow for custom lua and the toc functions.  
    - A migration layer is in place as well, but is not finalized at this time. Use with caution until it's in its v5 state.  
- [Change] Bumped Schema to 4.2 + Begin v2.2.0 Development  
    - This commit simply refactors the existing time conditional data to match it's variable names, cleaning up some duplicated logic. The migration layer v4.2 from v4.1 allows all prior settings to be retained.  
- [Change] Added an index param to `VersionToBuild`  
    - This will have a use in an upcoming update, which is in testing internally at this time. It is planned to release before 9.2.5s debut.  
- [Refactor] `GetPlaceholderArgs` => `GenerateDynamicTable`  
    - Changed to match `ParseDynamicTable`  
    - Aldo adjusted `IsToggleTag` to be marked as internal usage only.  
- [QOL] Several Config Optimizations  
    - [Refactor] Moved `DB\_DEFAULTS` as well as `GetDefaults` into a new `ProfileInfo` class, both for better segmenting and to avoid scrolling through 1000+ lines of code each time the config needs a change.  
    - [Refactor] `getOptionsTable` is now called `GetOptions` to follow other function formatting.  
    - Misc. Code Cleanup including unneeded commas and unneeded spacers in the General and Extra tab of the UI.  
    - The documentation for the end of option table generation has been adjusted to provide better clarity.  
- [QOL] Optimized the About Section of the Config UI  
    - Now multi-lined and color-coded!  
- [Fix] Fixed WagoAnalytics Shim Inclusion issues  
- Revert "[Change] Remove WagoAnalyticsShim due to inclusion incompatibilities"  
- [Change] Sync prior locale changes for deDE  
- [Change] Remove WagoAnalyticsShim due to inclusion incompatibilities  
    - I either did something wrong here, but this Shim has been removed due to both Legacy and retail inclusion failures.  
    - It technically was never needed anyways, since I have checks for the library to ensure it is present. These checks have been improved to prevent issues if it fails to load.  
- [QOL] Further locale changes to increase readability  
    - The optional migrations config comment's warning message has been rewritten to be more clear in its intent.  
    - The frame render size config comment has been adjusted to both be more clear and more accurately state it's intent with relation to the python script.  
    - All type variable config settings have had both their comments and usage statements re-done to better state their allowed values and to be more clear on it's intent.  
- [Fix] Fixed an additional typo in the Inactive type config comment  
- [QOL] Minor Locale Updates  
    - Added a failsafe for if the default locale fails to load.  
    - Added an additional newline between the config comment and the Default value line to further increase readability. Alongside this, a typo was fixed that caused the whole default line to be Green.  
    - Corrected the Extended Category title for Events to say `Available` rather then `Registered`.  
    - Added minor details to the Callback and Frame Clear Delay config comments.  
    Further changes to arrive soon.  
- Merge branch 'next'  
- [Fix] Fixed Shim inclusion for Classic Clients below or at 1.12.x  
- [Fix] Fixed a crash in `processCallback` with Analytics  
    - Sleepy person == Sleepy lua code  
- [Fix] Removed unused variable in Analytics\_Functions  
- [Change] Convert prior Metrics system to Dynamic Format  
    - This will allow much easier management of both present and future engines, and also allow what data users wish to send in addition to the prior enable ability. `processCallback` takes in arguments for `self, fieldName, oldValue, and newValue` while `stateCallback` is used for variable assignment and directly used for `processCallback`, so it just uses `self`.  
    - For debugging, a table called `registeredMetrics` has been added to see which metrics are currently active, in addition to seeing their callbacks (Again configurable from the config).  
- [Change] Added Build limitations for the time being  
    - The planned implementation for this will use a similar TOC and callback system to other parts of the addon, though to ensure compatibility, these limiters are in-place to prevent errors.  
- Merge branch 'master' into next  
- [Fix] Added Classic Era Helper Functions  
- [Change] Attempt to remove the limitation on clients for the time being  
- [Change] Initial Implementation of WagoAnalytics  
- [Change] Systems Prep for WagoAnalytics  
    - Added some additional Helper commands for determining the build the addon is running on  
- [Change] The error message for a byte overflow is now a non-debug error  
    - This is to prevent confusion in the scenario that an event fails to be processed due to exceeding the rpc limitations.  
- [Fix] Adjusted Labels category info text to display the more info cmd  
    - This was meant to be adjusted when the commands for this got added, but was forgotten.  
- [Change] Workflow support for Wrath Classic  
    - Currently commented out until Wrath Classic is available on applicable platforms  
- [Change] Further preliminary support for WOTLK Classic + Beta Clients  
    - Added flavor info for classic and retail beta clients, marked as 3.4.0 and 10.0.0  
    - Added a Wrath entry for TOC metadata, as the suffix has been confirmed today to be `_Wrath` with the version also confirmed as `3.4.0`  
- [Change] Added `RemoveDuplicateWords` to remove duplicate words  
    - Avoids scenarios such as `In Normal Scenario Scenario` or `Looking for Raid Raid`. This should have more of an impact with better legacy displays since Blizzard used this name scheme much more often in Classic then retail. This change will be configurable in a future update (Same as the MC version of this addon), and will only effect message data, not image keys).  
    - [Backend] `GetCaseData` has been adjusted to allow multiple Case Data Formats, which can be seperated by commas (For example, `GetCaseData({stringHere, "casing1,casing2"})`)  
- Code Cleanup + Documentation Consistency passthrough  
- [Backend] Fail-safe tweaks + Debugging Additions  
    - `ResetIndex` will now occur before the optionsTable is generated as well as after, to prevent malformed data in a scenario that `ResetIndex` is executed pre-maturely.  
    - Marked `ShouldProcessData#data` as a required parameter and adjusted method accordingly.  
    - Marked `SetInstanceChanged#value` as a required parameter and adjusted method accordingly.  
    - Marked `CreateFrames#size` as a required parameter and adjusted method accordingly.  
    - Marked `PaintFrame#frame` as a required parameter and adjusted method accordingly.  
    - Marked `PaintSomething#text` as a required parameter and adjusted method accordingly.  
    - Removed unnecesary semi-colon usage in `Utils.lua`  
    - Executing `ResetIndex` will now return `lastIndex` instead of returning `nil`, allowing knowledge of where the index is at any time.  
    - Marked `FormatAsIcon#str` as a required parameter and adjusted method accordingly.  
    - Marked `FormatWithCasing#str,casing` as required parameters and adjusted method accordingly.  
    - Marked `GetCaseData#obj` as a required parameter and adjusted method accordingly.  
    - `GetCaseData` can now be used with a table with one argument, in which case it will have the same return result as if you had supplied a string to it, rather then returning nil.  
    - Marked `GetGameVariable#str` as a required parameter and adjusted method accordingly  
    - `ShowConfig` will now return `self.optionsFrame` when applicable (Clients above 2.0.0). A proper return value is still being determined for <=1.12.1 clients).  
    - Marked `PrintUsageCommand#usage` as a required parameter and adjusted method accordingly.  
    - Marked `PrintQueryCommand#root\_name` as a required parameter and adjusted method accordingly.  
    - Marked `SetTimerLocked#newValue` as a required parameter and adjusted method accordingly.  
    - Marked `GetFromDb#grp` as a required parameter and `GetFromDb#key` as an optional parameter, and adjusted method accordingly. The same has been done for `SetToDb`.  
    - Adjusted the logic in `IsToggleTag` to prevent circumstances of it returning `nil` instead of a boolean.  
    - Executing `SetupQueueSystem` will now return the `queue\_frame` object, allowing better debugging capabilities within other addons.  
- [Cleanup] Indentation Cleanups  
- Merge branch 'next'  
